<template>
  <article class="view view--messaging-messages-overview">
    <FancyAlert v-if="usersListLink" type="info">
      If you want to start a conversation with a user you haven't spoken to yet, find them in the
      <router-link :to="usersRoute">users list</router-link>.
    </FancyAlert>
    <MessagingMessageList :offset="offset" :limit="limit" />
  </article>
</template>

<script>
import { computed } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { Constants, ValidationHelper, FancyAlert } from '../../../core'
import MessagingMessageList from '../../components/message-list.vue'

export default {
  name: 'MessagingMessagesOverviewView',
  components: {
    FancyAlert,
    MessagingMessageList,
  },
  setup() {
    const route = useRoute()
    const store = useStore()

    const usersListLink = computed(() => {
      return store.state.messaging.usersListLink
    })

    const usersRoute = computed(() => {
      return { name: 'identity-users' }
    })

    const offset = computed(() => {
      return ValidationHelper.getInteger(route.query.offset, 0)
    })

    const limit = computed(() => {
      return ValidationHelper.getInteger(route.query.limit, Constants.pagination.defaultPageLimit)
    })

    return {
      usersListLink,
      usersRoute,
      offset,
      limit,
    }
  },
}
</script>
